Prime Path(POJ--3126

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
题意:多组输入,每组输入两个数,求由前一个数到后一个数最少的步数。这两个数都是素数。
思路:先将1000~9999之间的素数求出来然后进行标记,然后从前一个数到后一个数进行BFS。

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
#define MAX 10005
#define mod 99991
using namespace std;
int n,x,y;
bool ha[MAX];
bool vis[MAX];
int sum[MAX];
void init()                //初始化,先将素数全部求出来,然后进行标记
{
    memset(ha,0,sizeof(ha));
    int m=sqrt(MAX+0.5);
    for(int i=2; i<=m; i++)
    {
        if(!ha[i])
        {
            for(int j=i*i; j<=MAX; j+=i)
                ha[j]=true;
        }
    }
}
void BFS()
{
    int a,b,c,d,e;
    queue<int>q;
    q.push(x);
    vis[x]=true;
    while(!q.empty())
    {
        int cc=q.front();
        q.pop();
        if(cc==y)
        {
            printf("%d\n",sum[cc]);
            return ;
        }
        a=cc%1000;
        for(int i=1000; i<=9000; i+=1000)     //只改变千位上的数
        {
            b=i+a;
            if(!ha[b]&&!vis[b])
            {
                sum[b]=sum[cc]+1;
                vis[b]=true;
                q.push(b);

            }
        }
        a=cc/1000;
        b=cc%100;
        for(int i=0; i<=900; i+=100)      //只改变百位上的数
        {
            c=a*1000+i+b;
            if(!ha[c]&&!vis[c])
            {
                sum[c]=sum[cc]+1;
                vis[c]=true;
                q.push(c);
            }
        }
        a=cc/1000;
        b=cc%1000;
        c=b/100;
        e=cc%10;
        for(int i=0; i<=90; i+=10)       //只改变十位上的数
        {
            d=a*1000+c*100+i+e;
            if(!ha[d]&&!vis[d])
            {
                sum[d]=sum[cc]+1;
                vis[d]=true;
                q.push(d);
            }
        }
        a=cc/10;
        for(int i=0; i<=9; i++)             //只改变个位上的数
        {
            b=a*10+i;
            if(!ha[b]&&!vis[b])
            {
                sum[b]=sum[cc]+1;
                vis[b]=true;
                q.push(b);
            }
        }
    }
}
int main()
{
    //freopen("lalala.text","r",stdin);
    scanf("%d",&n);
    while(n--)
    {
        init();
        memset(vis,0,sizeof(vis));
        memset(sum,0,sizeof(sum));
        scanf("%d %d",&x,&y);
        BFS();
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值